﻿SystemOrganization addCategory: #'Neo4reSt-Squeak-Core'!

WebRequest subclass: #N4WebJsonRequest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Neo4reSt-Squeak-Core'!

!N4WebJsonRequest methodsFor: 'initialize' stamp: 'mu 11/27/2011 17:14'!
forSendData
	self headerAt: 'Content-Type' put: 'application/json; charset=utf-8'.! !

!N4WebJsonRequest methodsFor: 'initialize' stamp: 'mu 11/27/2011 15:37'!
initialize
	super initialize.
	self headerAt: 'Accept' put: 'application/json'.! !

!N4WebJsonRequest methodsFor: 'initialize' stamp: 'mu 11/27/2011 15:33'!
newResponse
	"Create a new response entitiy.
	Subclasses can override this method to provide a different response class"

	^(N4WebJsonResponse new)
		request: self;
		yourself! !

!WebClient methodsFor: '*Neo4reSt-Squeak-Core' stamp: 'mu 2/17/2012 00:12'!
jsonDelete: urlString
		| request |
	self initializeFromUrl: urlString urlEncoded.
	request := self newJsonRequest initializeFromUrl: urlString urlEncoded.
	request method: 'DELETE'.
	userAgent ifNotNil:[request headerAt: 'User-Agent' put: userAgent].
	^self sendRequest: request! !

!WebClient methodsFor: '*Neo4reSt-Squeak-Core' stamp: 'mu 2/17/2012 00:11'!
jsonGet: urlString
	| request |
	self initializeFromUrl: urlString.
	request := self newJsonRequest initializeFromUrl: urlString urlEncoded.
	request method: 'GET'.
	userAgent ifNotNil:[request headerAt: 'User-Agent' put: userAgent].
	^self sendRequest: request
! !

!WebClient methodsFor: '*Neo4reSt-Squeak-Core' stamp: 'mu 2/17/2012 00:11'!
jsonPost: urlString
		| request |
	self initializeFromUrl: urlString.
	request := (self newJsonRequest initializeFromUrl: urlString urlEncoded) forSendData.
	request method: 'POST'.
	userAgent ifNotNil:[request headerAt: 'User-Agent' put: userAgent].
	^self sendRequest: request content: '' readStream size: 0! !

!WebClient methodsFor: '*Neo4reSt-Squeak-Core' stamp: 'mu 2/17/2012 00:12'!
jsonPost: urlString content: jsonString
	| request |
	self initializeFromUrl: urlString urlEncoded.
	request := (self newJsonRequest initializeFromUrl: urlString urlEncoded) forSendData.
	request method: 'POST'.
	request headerAt: 'Content-Length' put: jsonString size.
	userAgent ifNotNil:[request headerAt: 'User-Agent' put: userAgent].
	^self sendRequest: request content: jsonString readStream size: jsonString size! !

!WebClient methodsFor: '*Neo4reSt-Squeak-Core' stamp: 'mu 2/17/2012 00:12'!
jsonPut: urlString content: jsonString
	| request |
	self initializeFromUrl: urlString urlEncoded.
	request := (self newJsonRequest initializeFromUrl: urlString urlEncoded) forSendData.
	request method: 'PUT'.
	request headerAt: 'Content-Length' put: jsonString size.
	userAgent ifNotNil:[request headerAt: 'User-Agent' put: userAgent].
	^self sendRequest: request content: jsonString readStream size: jsonString size! !

!WebClient methodsFor: '*Neo4reSt-Squeak-Core' stamp: 'mu 11/27/2011 15:28'!
newJsonRequest
	^ N4WebJsonRequest new! !

N4PortableUtil subclass: #N4SqPortableUtil
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Neo4reSt-Squeak-Core'!

!N4SqPortableUtil class methodsFor: 'class initialization' stamp: 'mu 11/27/2011 16:17'!
initialize
	self activate! !

!N4SqPortableUtil methodsFor: 'actions' stamp: 'mu 12/23/2011 13:05'!
getJsonFrom: urlString 
	| response |
	response := self httpJsonGet: urlString.
	^self readJsonFromResponse: response! !

!N4SqPortableUtil methodsFor: 'accessing' stamp: 'mu 11/27/2011 16:37'!
httpClient
	
	^ WebClient new! !

!N4SqPortableUtil methodsFor: 'actions-http' stamp: 'mu 12/4/2011 15:59'!
httpJsonDelete: urlString 
	| resp |
	resp := self httpClient jsonDelete: urlString.
	resp code = 409 ifTrue: [^N4CannotDelete response: resp].
	^ resp! !

!N4SqPortableUtil methodsFor: 'actions-http' stamp: 'mu 11/29/2011 23:00'!
httpJsonGet: urlString
	| resp |
	resp := self httpClient jsonGet: urlString.
	self signalErrorBasedOn: resp.
	^ resp! !

!N4SqPortableUtil methodsFor: 'actions-http' stamp: 'mu 11/27/2011 16:36'!
httpJsonPost: urlString
	
	^ self httpClient jsonPost: urlString! !

!N4SqPortableUtil methodsFor: 'actions-http' stamp: 'mu 11/27/2011 16:52'!
httpJsonPost: urlString content: jsonString
	
	^ self httpClient jsonPost: urlString content: jsonString! !

!N4SqPortableUtil methodsFor: 'actions-http' stamp: 'mu 12/2/2011 00:03'!
httpJsonPut: urlString content: jsonString
	
	^ self httpClient jsonPut: urlString content: jsonString! !

!N4SqPortableUtil methodsFor: 'read/write' stamp: 'mu 12/23/2011 23:08'!
jsonStringFrom: valueOrAssocs 
	| dict rawJsonString param |
	(valueOrAssocs isArray or: [valueOrAssocs class = OrderedCollection])
		ifTrue: [dict := Dictionary new: valueOrAssocs size.
			dict addAll: valueOrAssocs.
			param := dict]
		ifFalse: [param := valueOrAssocs].
	rawJsonString := Json render: param.
	^ self utf8StringFrom: rawJsonString! !

!N4SqPortableUtil methodsFor: 'actions' stamp: 'mu 11/27/2011 16:39'!
postJson: json to: urlString

	! !

!N4SqPortableUtil methodsFor: 'actions' stamp: 'mu 11/27/2011 16:41'!
postJsonTo: urlString
	^self readJsonFrom: (self httpJsonPost: urlString) contentStream! !

!N4SqPortableUtil methodsFor: 'read/write' stamp: 'mu 11/27/2011 16:39'!
readJsonFrom: aStream

	^ Json readFrom: aStream! !

!N4SqPortableUtil methodsFor: 'actions' stamp: 'mu 12/24/2011 23:50'!
readJsonFromResponse: httpResponse
	| strm |
	"strm := (httpResponse headerAt: 'transfer-encoding') = 'chunked' ifTrue: [httpResponse content readStream] ifFalse: [httpResponse contentStream]."
	strm := httpResponse content readStream.
	^ self readJsonFrom: strm! !

!N4SqPortableUtil methodsFor: 'error handling' stamp: 'mu 11/29/2011 22:59'!
signalErrorBasedOn: response
	| code |
	code := response code.
	(code between: 200 and: 203) ifTrue: [^self].
	code = 204 ifTrue: [^ (N4NoContent response: response) signal].
	code = 404
		ifTrue: [^ (N4NotFound response: response) signal].
	^ (N4Error response: response) signal! !

!N4SqPortableUtil methodsFor: 'misc utils' stamp: 'mu 11/27/2011 23:58'!
string: aString beginsWith: prefix 
	^ aString beginsWith: prefix ! !

!N4SqPortableUtil methodsFor: 'read/write' stamp: 'mu 11/27/2011 17:15'!
utf8StringFrom: squeakString
	^ squeakString squeakToUtf8 ! !

WebResponse subclass: #N4WebJsonResponse
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Neo4reSt-Squeak-Core'!

!N4WebJsonResponse methodsFor: 'location-accessing' stamp: 'mu 12/9/2011 00:49'!
location
	^self headerAt: 'location' ifAbsent: []! !

!N4WebJsonResponse methodsFor: 'initialize' stamp: 'mu 12/7/2011 00:28'!
readFrom: aStream
	"Parse an HTTP response from the given stream"
	
	| space |
	stream := aStream.
	stream upToAll: 'HTTP/'.
	space := Character space.
	protocol := 'HTTP/', (stream upTo: space).
	code := [(stream upTo: space) asNumber] on: Error do: [^ self error:'Invalid response: ', stream upToEnd].
	status := code printString, ' ', (stream upToAll: String crlf).
	
	headers := WebUtils readHeadersFrom: stream.
! !
N4SqPortableUtil initialize!
